<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <script>
    "use strict";
    /* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
    */
    var gStudents = [
      {
        id: 2, // tự tăng
        studentCode: "1356783",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        studyYear: 2015
      },
      {
        id: 3, // tự tăng
        studentCode: "1234567",
        firstname: "Nguyen Van",
        lastname: "A",
        age: 20,
        email: "a@gmail.com",
        studyYear: 2019
      },
      {
        id: 4, // tự tăng
        studentCode: "1234568",
        firstname: "Nguyen Van",
        lastname: "B",
        age: 20,
        email: "b@gmail.com",
        studyYear: 2020
      },
      {
        id: 5, // tự tăng
        studentCode: "1234569",
        firstname: "Nguyen Van",
        lastname: "C",
        age: 22,
        email: "c@gmail.com",
        studyYear: 2021
      },
      {
        id: 6, // tự tăng
        studentCode: "1234569",
        firstname: "Nguyen Van",
        lastname: "D",
        age: 24,
        email: "c@gmail.com",
        studyYear: 2018
      },

    ];

    var gSubjects = [
      {
        id: 5, // tự tăng
        subjectCode: "MATH101",
        subjectName: "Toán cao cấp 1"
      },
      // điền thêm 04 môn học nữa
      {
        id: 6, // tự tăng
        subjectCode: "CT449",
        subjectName: "Phát triển ứng dụng web"
      },
      {
        id: 7, // tự tăng
        subjectCode: "CT223",
        subjectName: "An toàn hệ thống"
      },
      {
        id: 8, // tự tăng
        subjectCode: "CT484",
        subjectName: "Phát triển ứng dụng di động"
      },
      {
        id: 9, // tự tăng
        subjectCode: "CT300",
        subjectName: "Phát triển phần mềm"
      },
    ];

    var gGrades = [
      {
        id: 2, // tự tăng
        studentId: 2,
        subjectId: 5,
        grade: 8,
        examDate: "13/04/2021"
      },
      // điền thêm 9 kết quả thi nữa
      {
        id: 3, // tự tăng
        studentId: 3,
        subjectId: 6,
        grade: 9,
        examDate: "13/04/2021"
      },
      {
        id: 4, // tự tăng
        studentId: 4,
        subjectId: 7,
        grade: 10,
        examDate: "15/04/2021"
      },
      {
        id: 5, // tự tăng
        studentId: 5,
        subjectId: 8,
        grade: 7,
        examDate: "17/04/2021"
      },
      {
        id: 6, // tự tăng
        studentId: 6,
        subjectId: 9,
        grade: 9,
        examDate: "13/04/2021"
      },
      {
        id: 7, // tự tăng
        studentId: 2,
        subjectId: 5,
        grade: 9,
        examDate: "13/04/2021"
      },
      {
        id: 8, // tự tăng
        studentId: 3,
        subjectId: 6,
        grade: 9,
        examDate: "13/04/2021"
      },
      {
        id: 9, // tự tăng
        studentId: 4,
        subjectId: 8,
        grade: 8,
        examDate: "13/04/2021"
      },
      {
        id: 10, // tự tăng
        studentId: 3,
        subjectId: 7,
        grade: 10,
        examDate: "13/04/2021"
      },
      {
        id: 11, // tự tăng
        studentId: 2,
        subjectId: 9,
        grade: 9,
        examDate: "13/04/2021"
      },


    ];
  </script>
</head>

<body>
  <div class="container">
    <div>
      <h2 class="text-center">
        F200-LỊCH SỬ HỌC TẬP
      </h2>
    </div>
    <div class="jumbotron">
      <div class="row">
        <h2 class="col-sm-12 mb-3">Thông tin người chơi:</h2>
      </div>

      <div class="row form-group">

        <div class="col-sm-2 text-right">
          <label for="">Student</label>
        </div>
        <div class="col-sm-3">
          <select name="" id="select-student" class="form-control">
            <option value="0">Chọn student</option>
          </select>
        </div>
        <div class="col-sm-2 text-right">
          <label for="">Subject</label>
        </div>
        <div class="col-sm-3">
          <select name="" id="select-subject" class="form-control">
            <option value="0">Chọn subject</option>
          </select>
        </div>
        <div class="col-sm-2 text-right">
          <button id="btn-filter" class="btn btn-success">Lọc dữ liệu</button>
        </div>

      </div>
    </div>

    <table id="student-table" class="table table-bordered table-striped">
      <thead>
        <tr class="bg-primary text-white">
          <th>STT</th>
          <th>Student</th>
          <th>Môn học</th>
          <th>Điểm</th>
          <th>Ngày thi</th>
        </tr>

      </thead>
      <tbody class="table-primary">

      </tbody>
    </table>

  </div>
</body>
<script>
  console.log(gGrades);
  console.log(gStudents[0].id);
  console.log(gSubjects);

  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  gCOL_NAME = ["id", "studentId", "subjectId", "grade", "examDate"];
  gID_COL = 0;
  gSTUDENT_ID_COL = 1;
  gSUBJECT_ID_COL = 2;
  gGRADE_COL = 3;
  gEXAM_DATE_COL = 4;
  var gStt = 1;


  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading();
    onPageLoadingSelect();
    $("#btn-filter").on("click", function () {
      onBtnFilterData();
    })
  })

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    $("#student-table").DataTable({
      data: gGrades,
      columns: [
        { data: gCOL_NAME[gID_COL] },
        { data: gCOL_NAME[gSTUDENT_ID_COL] },
        { data: gCOL_NAME[gSUBJECT_ID_COL] },
        { data: gCOL_NAME[gGRADE_COL] },
        { data: gCOL_NAME[gEXAM_DATE_COL] },
      ],
      columnDefs: [
        {
          targets: gID_COL,
          render: chuyenId,
          class: "text-center"
        },
        {
          targets: gSTUDENT_ID_COL,
          render: getDataStudentNameById,
          class: "text-center"
        },
        {
          targets: gSUBJECT_ID_COL,
          render: getDataSubjectNameById,
          class: "text-center"
        },
        {
          targets: gGRADE_COL,
          class: "text-center"
        }
      ]
    })
  }
  // select student
  function onPageLoadingSelect() {
    for (var bI = 0; bI < gStudents.length; bI++) {
      $("#select-student").append($("<option>", {
        value: gStudents[bI].id,
        text: gStudents[bI].firstname + " " + gStudents[bI].lastname
      }))
    }
    for (var bI = 0; bI < gSubjects.length; bI++) {
      $("#select-subject").append($("<option>", {
        value: gSubjects[bI].id,
        text: gSubjects[bI].subjectName
      }))
    }

  }
  // chức năng filter
  function onBtnFilterData() {
    var vStudentObj = {
      idStudent: -1,
      idSubject: -1,
    }
    // b1 thu thap thong tin
    getDataStudent(vStudentObj);
    // b2 validate(bo qua)
    // b3 xu ly filter
    var vDataObjStudent = {};
    var vDataObjSubject = {};
    var vDataObjAll = {};
    vDataObjStudent = filterDataStudent(vStudentObj);
    vDataObjSubject = filterDataSubject(vStudentObj);
    vDataObjAll = filterDataAll(vStudentObj);
    // hien thi  
    if (vStudentObj.idStudent != 0 && vStudentObj.idSubject != 0) {
      displayShowData(vDataObjAll);
    }
    else if (vStudentObj.idStudent == 0) {
      displayShowData(vDataObjSubject);
    }
    else if (vStudentObj.idSubject == 0) {
      displayShowData(vDataObjStudent);
    }

  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // thu thap thong tin
  function getDataStudent(paramStudent) {
    paramStudent.idStudent = $("#select-student").val();
    paramStudent.idSubject = $("#select-subject").val();
  }
  // filter 
  function filterDataStudent(paramStudent) {
    var vResult = [];
    vResult = gGrades.filter(function (item) {
      return paramStudent.idStudent == item.studentId;
    })
    return vResult;
  }

  function filterDataAll(paramAll) {
    var vResult = [];
    vResult = gGrades.filter(function (item) {
      return paramAll.idStudent == item.studentId && paramAll.idSubject == item.subjectId;
    })
    return vResult;
  }
  function filterDataSubject(paramSubject) {
    var vResult = [];
    vResult = gGrades.filter(function (item) {
      return paramSubject.idSubject == item.subjectId;
    })
    return vResult;
  }
  // show
  function displayShowData(paramData) {
    gStt = 1;
    var vTable = $("#student-table").DataTable();
    vTable.clear();
    vTable.rows.add(paramData);
    vTable.draw();
  }
  function chuyenId() {
    return gStt++;
  }
  // render student
  function getDataStudentNameById(paramData, pramType, pramRow) {
    var vTimThay = false;
    var vStudentName = "";
    var vIndex = 0;
    while (!vTimThay && vIndex < gStudents.length) {
      if (gStudents[vIndex].id == paramData) {
        vStudentName = gStudents[vIndex].firstname + " " + gStudents[vIndex].lastname
      }
      vIndex++;
    }
    return vStudentName;

  }
  // render subject name
  function getDataSubjectNameById(paramData) {
    var vTimThay = false;
    var vSubjectName = "";
    var vIndex = 0;
    while (!vTimThay && vIndex < gSubjects.length) {
      if (gSubjects[vIndex].id == paramData) {
        vSubjectName = gSubjects[vIndex].subjectName;
      }
      vIndex++;
    }
    return vSubjectName;
  }



</script>

</html>